<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of tagSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# tagSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# tagSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with tagSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

class tagSwitcher {

	/**
	@function readConf

	Cette fonction permet de lire le fichier de confiugration de tagSwitcher
	*/
	function readConf(){
		$tagSwitcher_config_file = DC_SHARE_DIR.'/tagSwitcher/tagSwitcher.conf';

		if ( !file_exists($tagSwitcher_config_file) ) {
			return false;
		}

		$tagSwitcher_config = new iniFile($tagSwitcher_config_file);
		$tagSwitcher_config->read($tagSwitcher_config_file);

		if ( !defined('ACTIVE_JS') ||  !defined('FIRST') ) {
			return false;
		}

		return true;
	}



	/**
	@function tagList

	Cette fonction affiche la liste des tags, soit comme la mthode twTags::tagList()
	du plugin twTags ou sous forme de liste droulante, ou les deux.

	@param  mixed   tag_select    Tags  afficher en tant que liste droulante.
	                              Ce paramtre peut tre :
	                                + un tableau (listant les tags)
	                                + une expression rgulire (base sur les tags)
	                                  ssi $regex_mode = true
	                                + la valeur 'ALL' pour tous les tags
	
	@param  boolean regex_mode    Active ou non le mode regex (true|false) pour tag_select
	
	@param  mixed   tag_deselect  Tags  ne pas afficher 
	                              Ce paramtre peut tre :
	                                + un tableau (listant les tags)
	                                + une expression rgulire (base sur les tags)
	                                  ssi $regex_mode2 = true
	
	@param  boolean regex_mode2   Active ou non le mode regex (true|false) pour tag_deselect
	
	@param  string  tag_block     Mise en forme du bloc "Tags" avec les tags en dehors et
	                              dedans la liste droulante (%1$s correspond aux tags et %2$d
	                              correspond  la liste droulante
	
	@param  string  block         Mise en forme de la liste des tags non compris dans la
	                              liste droulante
	
	@param  string  item          Mise en forme des lments de la liste des tags non compris
	                              dans la liste droulante
	*/

	function tagList( $tag_select=array(), $regex_mode=false, 
	                  $tag_deselect=array(), $regex_mode2=false,
	                  $tag_block='%1$s %2$s',
	                  $block='<ul>%s</ul>', $item='<li>%s</li>') {

		global $blog, $tag_id;

		// test if twTags class exists
		if(class_exists('twTags')) $rec = twTags::_recordset();
		else exit;


		// if we have records
		if ($rec) {

			# read conf
			$conf = tagSwitcher::readConf();

			$rec->moveStart();

			$res = '';

			if($conf) {
				$list = '<option value="" >'.FIRST.'</option>'; //la premire valeur
			}
			else {
				$list = '';
			}

			$tags = '';

			$liens = '';

			while ($rec->fetch()) {

				$tag_libelle = $rec->f('meta_value');
				$tag_url = twTags::_url($tag_libelle);

				// Test pour savoir s'il doit tre affich
				if ( ( is_array($tag_deselect) && ( !in_array($tag_libelle, $tag_deselect) ) ) ||
				     ( $regex_mode2 && ( !ereg($tag_deselect,$tag_libelle) ) )
				   ) {

					// Test pour savoir s'il doit tre dans la liste droulante
					// Si la conf n'a pas pu tre lue, on met tout dans une liste comme d'hab
					// cad pas ds la droulante
					if ( $conf &&
							 ( $tag_select === 'ALL' ) ||
					     ( is_array($tag_select) && ( in_array($tag_libelle, $tag_select) ) ) ||
					     ( $regex_mode && ereg($tag_select,$tag_libelle) )
					   ) {
						// libelle du tag sans caractres spciaux
						$tag_libelle2 = $blog->str2url($tag_libelle);

						$list.= '<option id="tS_option_' . $tag_libelle2 . '" ' .
						        'label="tS_option_' . $tag_libelle2 . '" ' .
						        'value="' . $tag_libelle . '" ' . (($tag_id == $tag_libelle) ? 'selected ': '' ) . ' >' .
						        htmlspecialchars($tag_libelle) .
						        '</option>';
					}
					// Sinon afficher en dehors de la liste droulante
					else {
						$lien = '<a href="'.$tag_url.'">'.htmlspecialchars($tag_libelle).'</a>';

						if ($tag_id == $tag_libelle) {
							$lien = '<strong>'.$lien.'</strong>';
						}

						$liens .= sprintf($item,$lien);
					}
				}
			}

			$rec->moveStart();

			if($conf){
				$form = '<form id="tS_form" method="post" action="'.dc_app_url.'/ecrire/tools/tagSwitcher/redirect.php" >'."\n".
			          '<p id="tS_p_form">'."\n".
			          '<select id="tS_select" name="tag" size="1" ';

				if(ACTIVE_JS) $form.= 'onchange="this.form.submit();"';

				$form.= '>'."\n".
				        $list."\n".
				        '</select>'."\n".
				        '<input id="tS_submit" type="submit" value="go">'."\n".
				        '</p>'."\n".
				        '</form>'."\n";
			}

			if( $liens != '') $liens = sprintf($block, $liens);

			printf($tag_block,$liens,$form);
		}
	}


	/**
	@function       hideSubmitButton

	Cette fonction permet d'afficher ou non le bouton "Go" (ou "Aller" en franais :) )
	affich  ct de la liste droulante. Cette fonction permet simplement d'inclure un
	fichier javascript qui :
	
		1 - Si javascript est activ et le paramtre active de la fonction est  true, permet
		    d'effacer el bouton ( l'aide de DOM et Cie)

		2 - Si javascript est activ et le paramtre active est  false, laisse le bouton

		3 - si javascript n'est pas activ, affiche le bouton.
	*/


	function hideSubmitButton(){
		# read conf
		if ( !($conf = tagSwitcher::readConf()) ) exit;

		if (ACTIVE_JS)
			echo '<script src="'.dc_app_url.'/ecrire/tools/tagSwitcher/tagSwitcher.js" type="text/javascript"></script>'."\n";
	}

}

?>
