<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of tagSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# tagSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# tagSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with tagSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

function tagSwitcher_error($error) {
	buffer::str('<div class="error">'.__('ERROR:').' '.$error.'</div>');
}


function tagSwitcher_form_config(){
	global $url;

	$active_js = (defined('ACTIVE_JS')) ? ACTIVE_JS : '';
	$first     = (defined('FIRST'))     ? FIRST     : '';

	buffer::str('<h3>'.__('tagSwitcher Configuration').'</h3>');

	buffer::str('<form action="'.$url.'" method="post">');

	# checkbox : tagSwitcher_activejs
	buffer::str('<p>'.form::checkbox('tagSwitcher_activejs','true',$active_js,'','tagSwitcher_activejs').
	            __('Activate tagSwitcher Javascript').' '.
	            helpLink('tagSwitcher_config&plugin=tagSwitcher','tagSwitcher_activejs').
	            '</label>'.'</p>');

	# field : tagSwitcher_first
	buffer::str('<p>'.
	            '<label for="tagSwticher_first">'.
	            '<strong>'.__('tagSwitcher first value').'&nbsp;: </strong> '.
	            helpLink('tagSwitcher_config&plugin=tagSwitcher','tagSwitcher_first').
	            '</label>'.
	            form::field('tagSwitcher_first',40,255,$first,'','class="max"').
	            '</p>');

	buffer::str('<br />');

	buffer::str('<p><input class="submit" type="submit" name="submit" value="'.
	            __('save').'" /></p>');
	buffer::str(form::hidden('updConfig','true'));
	buffer::str('</form>');

}


function tagSwitcher_save_config(){
	global $tagSwitcher_config;

	$tagSwitcher_activejs = (!empty($_POST['tagSwitcher_activejs'])) ? $_POST['tagSwitcher_activejs'] : 'true';
	$tagSwitcher_first    = (!empty($_POST['tagSwitcher_first']))    ? $_POST['tagSwitcher_first']    : '---';

	$tagSwitcher_config->editVar('ACTIVE_JS', $tagSwitcher_activejs);
	$tagSwitcher_config->editVar('FIRST', $tagSwitcher_first);
	$tagSwitcher_config->saveFile();

	tagSwitcher_help();
}


function tagSwitcher_help() {
	buffer::str('<fieldset class="clear"><legend>'.__('Modify your template.php').'</legend>');

	buffer::str('<p>'.__('To use tagSwitcher, it\'s very simple:').'</p>');

	buffer::str('<ol><li>'.__('Find in your template.php the bloc about the tags:'));

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<div id="tags">').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<h2>'.__('Tags').'</h2>').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<?php twTags::tagList(); ?>').'<br />');
	buffer::str(htmlspecialchars('</div>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('And remplace it by:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<div id="tags">').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;'.htmlspecialchars('<h2>'.__('Tags').'</h2>').'<br />');
	buffer::str('&nbsp;&nbsp;&nbsp;&nbsp;<b>'.htmlspecialchars('<?php tagSwitcher::tagList(); ?>').'</b><br />');
	buffer::str(htmlspecialchars('</div>'));
	buffer::str('</div>');

	buffer::str('</li>');

	buffer::str('<li>'.__('Find in your template.php this line (in head bloc):'));

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<link rel="stylesheet" type="text/css" href="<?php dcInfo(\'theme\'); ?>/style.css" media="screen" />'));
	buffer::str('</div>');

	buffer::str('<p>'.__('And add this line (in bold):').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<link rel="stylesheet" type="text/css" href="<?php dcInfo(\'theme\'); ?>/style.css" media="screen" />').'<br />');
	buffer::str('<b>'.htmlspecialchars('<?php tagSwitcher::hideSubmitButton(); ?>').'</b>');
	buffer::str('</div>');

	buffer::str('</li>');

	buffer::str('</ol>');

	buffer::str('</fieldset>');

	buffer::str('<fieldset class="clear"><legend>'.__('How tagSWitcher works (parameters and Co)').'</legend>');
	buffer::str('<p>'.__('tagSwitcher::tagList() works like twTags::tagList() by default.').'</p>');
	buffer::str('<p>'.__('Tags that are not in the drop-down list are print like with twTags::tagList().').'</p>');
	buffer::str('<p>'.__('But it accept parameters').' :D. '.__('You can give it an array with the tags to include in the drop-down list.'));

	buffer::str('<p>'.__('Take this list of tags for example:').'</p>');
	buffer::str('<ul><li>'.__('General').'</li>');
	buffer::str('<li>'.__('Electronics').'</li>');
	buffer::str('<li>'.__('Internet').'</li>');
	buffer::str('<li>'.__('Language').'</li>');
	buffer::str('<li>'.__('Music').'</li></ul>');

	buffer::str('<p>'.__('If you want to include "Language" and "Music" in your drop-down list, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList( array(\'Language\',\'Music\') ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('But it\'s not all folks !').' '.__('You can use regular expressions.').' '.__('For example, if you want to include all tags that begin with the letter \'E\' in your drop-down list, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList( \'^E\', true ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('The second parameter active the regex mode (false by default)').'</p>');

	buffer::str('<p>'.__('If you want to include all tags in your drop-down list, tagSwitcher use a special parameter:').'\'ALL\'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList( \'ALL\' ); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('If you want to include all tags in your drop-down list but you don\'t want to view \'General\' tag in your lists (normal and drop-down), you\'ll use:').'</p>'); 

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList(\'ALL\', false, array(\''.__('General').'\')); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('The two first parameters do not change and have the same signification. The third parameter has the same signification that the first parameter: it can be an array of tags to not print, or a regular expression which will be activate with the fourth parameter set to true.').'</p>');
	buffer::str('<p>'.__('By example, if you don\'t want to print all tags that begin with \'Lang\', you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList(\'ALL\', false, \'^Lang\', true); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('Another example. If you don\'t want to print \'General\' tag and you want to include all the tags that begin with \'Blog\' in your drop-down list, the remaining tags will be in normal list as usual, you\'ll use:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList(\'^Blog\', true, array(\''.__('General').'\')); ?>'));
	buffer::str('</div>');

	buffer::str('<p>'.__('Last example. You don\'t want to print all tags that begin with \'Tag\', and you want to include \'General\', \'Electronic\' and \'Internet\' in your drop-down list, you\'ll use:').'</p>'); 

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList(array(\''.__('General').'\', \''.__('Electronic').'\', \''.__('Internet').'\'), false, \'^Tag\', true); ?>'));
	buffer::str('</div>');

	buffer::str('<br />');

	buffer::str('<p>'.__('You can format the tags bloc.').' '.__('For example:').'</p>');

	buffer::str('<div class="code">');
	buffer::str(htmlspecialchars('<?php tagSwitcher::tagList( \'^Tag\', true, \'\', \'\', \'<div>%1$s</div><div>Tags : %2$s</div>\', \'<ul>%s</ul>\', \'<li>%s</li>\' ); ?>'));
	buffer::str('</div>');

	buffer::str('<ul><li>');
	buffer::str('<b>\''.htmlspecialchars('<div>%1$s</div><div>Tags : %2$s</div>').'\'</b> '.__('is the entiere Tags bloc, with simple list and drop-down list').'. '.
	__('The first %1$s is the simple list.').' '.__('The second %2$s is the drop-down list.').'</li>');
	buffer::str('<li><b>\''.htmlspecialchars('<ul>%s</ul>').'\'</b> '.__('and').' <b>\''.htmlspecialchars('<li>%s</li>').'\'</b> '.__('is the simple list format like in the function twTags::tagList()').'.</li></ul>');

	buffer::str('</fieldset>');
}

?>
