<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of tagSwitcher plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# tagSwitcher is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# tagSwitcher is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with tagSwitcher; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


$error = '';

# configuration de tagSwitcher
require_once $_SERVER['DOCUMENT_ROOT'].'/'.dc_app_url.'/inc/classes/class.ini.file.php';

$tagSwitcher_config_file = DC_SHARE_DIR.'/tagSwitcher/tagSwitcher.conf';

if (!file_exists(dirname($tagSwitcher_config_file))) {
	if ( !files::makeDir(dirname($tagSwitcher_config_file)) ) {
		$error = sprintf(__('Immpossible to create %s directory.'),dirname($tagSwitcher_config_file));
	}
}

if ($error == '' && !file_exists($tagSwitcher_config_file)) {
	if ( !touch($tagSwitcher_config_file) ) {
		$error = sprintf(__('Impossible to create %s configuration file.'), $tagSwitcher_config_file);
	}
	else {
		$fp = fopen($tagSwitcher_config_file, 'w');
		if ( !fwrite($fp, 'ACTIVE_JS = true'."\n".'FIRST = ---') ){
			$error = __('Impossible to write in configuration file.');
		}
	}
}

if ($error == '') {
	$tagSwitcher_config = new iniFile($tagSwitcher_config_file);
	$tagSwitcher_config->read($tagSwitcher_config_file);
	if ( !defined('ACTIVE_JS') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'ACTIVE_JS');
	}
	elseif ( !defined('FIRST') ) {
		$error = sprintf(__('Bad configuration file: no %s option defined.'), 'FIRST');
	}
}



# Rcupration du fichier de langue pour la page Help
#if (dc_encoding == 'UTF-8') {
#        l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'-utf8/help');
#}
#else {
#        l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'/help');
#}


# les fonctions pour l'interface admin
#require_once dirname(__FILE__).'/inc/function_admin.php';
require_once 'inc/admin_functions.php';

# style supplmentaire pour l'interface tagSwitcher
$PLUGIN_HEAD =  '  <style type="text/css"> @import "tools/tagSwitcher/main.css"; </style>'."\n";

$url = 'tools.php?p=tagSwitcher';


# pour l'affichage de la page de configuration de tagSwitcher
$config = (!empty($_GET['config'])) ? $_GET['config'] : '';

# pour l'enregistrement de la configuration
$updConfig = (!empty($_POST['updConfig'])) ? $_POST['updConfig'] : 'false';

# pour l'affichage de la page d'aide (affiche par dfaut = '1')
$help = (!empty($_GET['help'])) ? $_GET['help'] : '1';



$version = $plugins_list['tagSwitcher']['version'];


# titre de la page d'administration du plugin tagSwitcher
buffer::str('<h2>tagSwitcher '.$version.'</h2>');


# le menu de tagSwitcher
buffer::str('<div id="menu">'.
		'<a href="'.$url.'&config=1" '.(($config!='') ? 'id=selected':'').' >'.__('Configuration').'</a>'.
		'<a href="'.$url.'&help=1" '.(($help!='') ? 'id=selected':'').' >'.__('Help').'</a>'.
		'</div>');
buffer::str('<br />');



if ( $error != '' ) {
	tagSwitcher_error($error);
}
else {
		if ($config == '1') {
			tagSwitcher_form_config();
		}

		# sinon on enregistre la configuration
		elseif ($updConfig == 'true') {
			tagSwitcher_save_config();
		}

		# sinon on affiche l'aide de tagSwitcher
		elseif ($help == '1') {
			tagSwitcher_help();
		}
}

?>
